/************************************************************************
 *                                                                      *
 * Intro-sreen for Ron Carr's RC-Fly 16                                 *
 *                                                                      *
 * ver. 1.1                                                                          23.02.1999 *
 *                                                                      *
 ************************************************************************/

#define VERSION "   Version 1.9"

#include <stdio.h>
#include <graphics.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>
#include <time.h>

int port;
int invert;
int delay_val;
int status;
int control;


main(int argc, char * argv[]){

   intro( argc );
}

#define NOPLANES 20

void whatplane( char * choice, int column ){  /* ask user what plane he/she wants to fly */

struct ffblk files;
char temps[40][NOPLANES];
int i,k;
char *p;
char line[60];


   if( findfirst("*.par",&files,FA_NORMAL) ) return;  /* none found */
   i= 1;
   strcpy( temps[0], files.ff_name );
   p= temps[0];
   while ( *p != '.' ) ++p;
   *p= 0;                   /* chop off the file extension */

   while ( findnext(&files ) == 0 ){
      strcpy( temps[i],files.ff_name );
      p= temps[i];
      while (*p != '.' ) ++p;
      *p= 0;
      ++i;
      if( i == NOPLANES ) --i;
      }
  /* we now have all the names, so ask the user which one */
  for( k= 0; k < i; ++k, column+= 10 ){
     sprintf(line,"'%d' - %s",k+1,temps[k]);
     outtextxy(20,column,line);
     }
  outtextxy(15,column,"Enter a number...");
  while ( k < 0 || k >= i ){
    k= getch() - '1';
    }

  strcpy ( choice, temps[k] );

}



intro(int debug_flag ){
        int   x;
        char  plane[20]="bipe";
        char  command[50];

        int             airplane[28];
        int             airplaneX,
                        airplaneY;
        float   fRatio = 0.6*2;

        int             field[15],
                        fieldX,
                        fieldY;

        int             graphics_modes,
                        graphics_drivers;

        /* Init graphics */

        graphics_drivers = EGA;
        graphics_modes   = EGA64HI;
        initgraph(&graphics_drivers, &graphics_modes, "");

        if (graphresult() != grOk)

        {
                printf("Could not initialize graphics!\n");
                exit(0);
        }

        /* draw background bars: */

        /* Left rectangle       */
        setfillstyle(SOLID_FILL, CYAN);
        bar(0, 0, 200, 340);

        /* Right rectangle upper     */
        setfillstyle(SOLID_FILL, LIGHTBLUE);
        bar(200, 0, 600, 340);

        /* Right rectangle down    */
        setfillstyle(SOLID_FILL,LIGHTGREEN);
        bar(200, 200, 600, 340);

        /* Rectangle                */
        setcolor(WHITE);
        rectangle(0, 0, 600, 340);

        /* Sun*/
        setcolor(YELLOW);
        setfillstyle(SOLID_FILL, YELLOW);
        fillellipse(520, 50, 25, 25);

        /* Clouds*/
        setcolor(WHITE);                     /*cloud 1*/
        setfillstyle(SOLID_FILL, WHITE);
        fillellipse(230, 50, 25, 20);
        setcolor(WHITE);
        setfillstyle(SOLID_FILL, WHITE);
        fillellipse(250, 50, 25, 25);
        setcolor(WHITE);
        setfillstyle(SOLID_FILL, WHITE);
        fillellipse(270, 50, 25, 20);

        setcolor(WHITE);                     /*cloud 2*/
        setfillstyle(SOLID_FILL, WHITE);
        fillellipse(330, 40, 15, 10);
        setcolor(WHITE);
        setfillstyle(SOLID_FILL, WHITE);
        fillellipse(350, 40, 15, 15);
        setcolor(WHITE);
        setfillstyle(SOLID_FILL, WHITE);
        fillellipse(370, 40, 15, 10);

        setcolor(WHITE);                      /*cloud 3*/
        setfillstyle(SOLID_FILL, WHITE);
        fillellipse(400, 30, 5, 6);
        setcolor(WHITE);
        setfillstyle(SOLID_FILL, WHITE);
        fillellipse(410, 30, 5, 8);
        setcolor(WHITE);
        setfillstyle(SOLID_FILL, WHITE);
        fillellipse(420, 30, 5, 6);

        setcolor(WHITE);                       /*cloud 4*/
        setfillstyle(SOLID_FILL, WHITE);
        fillellipse(440, 25, 3, 3);
        setcolor(WHITE);
        setfillstyle(SOLID_FILL, WHITE);
        fillellipse(445, 25, 3, 4);
        setcolor(WHITE);
        setfillstyle(SOLID_FILL, WHITE);
        fillellipse(450, 25, 3, 3);


        /* draw field*/
        fieldX = 0;
        fieldY = 0;
        fRatio = 1;

        field[0] = fieldX + 200;/*field*/
        field[1] = fieldY + 230 * fRatio;
        field[2] = fieldX + 450;
        field[3] = fieldY + 200 * fRatio;
        field[4] = fieldX + 550;
        field[5] = fieldY + 200 * fRatio;
        field[6] = fieldX + 200;
        field[7] = fieldY + 300 * fRatio;
        field[8] = fieldX + 200;/*line*/
        field[9] = fieldY + 264 * fRatio;
        field[10] = fieldX + 499;
        field[11] = fieldY + 200 * fRatio;
        field[12] = fieldX + 501;
        field[13] = fieldY + 200 * fRatio;
        field[14] = fieldX + 200;
        field[15] = fieldY + 266 * fRatio;

        setfillstyle(SOLID_FILL, LIGHTGRAY);
        fillpoly(4, field);
        setfillstyle(SOLID_FILL, WHITE);
        fillpoly(4, field+8);


        /* draw airplane */
        airplaneX = 0;
        airplaneY = 0;
        fRatio    = 1;

        airplane[0] = airplaneX + 470;  /* fuse */
        airplane[1] = airplaneY + 160 * fRatio;
        airplane[2] = airplaneX + 580;
        airplane[3] = airplaneY + 105 * fRatio;
        airplane[4] = airplaneX + 580;
        airplane[5] = airplaneY + 115 * fRatio;
        airplane[6] = airplaneX + 485;
        airplane[7] = airplaneY + 165 * fRatio;

        airplane[8] = airplaneX + 425;  /*wing*/
        airplane[9] = airplaneY + 115 * fRatio;
        airplane[10] = airplaneX + 490;
        airplane[11] = airplaneY + 150 * fRatio;
        airplane[12] = airplaneX + 585;
        airplane[13] = airplaneY + 160 * fRatio;
        airplane[14] = airplaneX + 595;
        airplane[15] = airplaneY + 150 * fRatio;
        airplane[16] = airplaneX + 530;
        airplane[17] = airplaneY + 140 * fRatio;
        airplane[18] = airplaneX + 440;
        airplane[19] = airplaneY + 113 * fRatio;

        airplane[20] = airplaneX + 550;  /*Hhe*/
        airplane[21] = airplaneY + 105 * fRatio;
        airplane[22] = airplaneX + 590;
        airplane[23] = airplaneY + 120 * fRatio;
        airplane[24] = airplaneX + 600;
        airplane[25] = airplaneY + 115 * fRatio;
        airplane[26] = airplaneX + 560;
        airplane[27] = airplaneY + 100 * fRatio;

        setfillstyle(SOLID_FILL, RED);
        fillpoly(4, airplane);
        setfillstyle(SOLID_FILL, YELLOW);
        fillpoly(6, airplane + 8);
        fillpoly(4, airplane + 20);


                /* draw text */

        setcolor(WHITE);
        outtextxy(20,  20, " Welcome to FlyRC");
        outtextxy(20,  40, VERSION);
        outtextxy(20,  60, "(c) 1998 by Ron Carr");

        outtextxy(20,  90, "Controls as follows!");
        outtextxy(20, 100, "'1' - '9' = throttle");
        outtextxy(20, 110, "'f'       = joy rate +");
        outtextxy(20, 120, "'s'       = joy rate -");
        outtextxy(20, 130, "'i'       = reset");
        outtextxy(20, 140, "'q'       = quit");


        setcolor(BLACK);
        outtextxy(20,320, "Programming by Ron Carr, Wilfried Fedtke ");
        outtextxy(20,330, "Designs by Ron Carr, Wilfried Fedtke, Eric Middeldorp, Danie Marais");

        setcolor(YELLOW);
        outtextxy(10, 160, "Select a plane to fly");
        whatplane( plane, 170 );

        closegraph();
        if( findradio() ) sprintf(command,"fly %s -t %d %d %d",plane,port,invert,delay_val);
        else sprintf(command,"fly %s",plane);
        if( debug_flag == 2 ){
           printf("%s   -- Hit a key\n",command);
           getch();
           }
        system(command);


}

int find_signal(){     /* see if have a signal on parallel port */
time_t counter;
int val;

    counter= clock() + 20;
    val = inportb(status) & 0x40;
    while( clock() < counter ){
       if( (inportb(status) & 0x40 ) != val ) return 1;
       }
    return 0;

}

find_invert(){   /* look at duty cycle */
long high;
long low;
time_t counter;
int val;

   low= high= 0;
   counter= clock() + 5;
   while ( clock() < counter ){
      val= inportb(status) & 0x40;
      if( val ) ++high;
      else ++low;
      }

   if( low > high ) invert = 0x40;

}

int count_high(){
int count;
int val;
   do{
      val= (inportb(status) & 0x40 ) ^ invert;
      }while( val == 0 );
   count= 0;
   while( ( inportb(status) & 0x40 ) ^ invert ){
       ++count;
       }
   return count;
}



find_delay(){   /* assume no stick input at this time */
int vals[20];
int x,y;
FILE * fp;

   fp= fopen( "radio.cfg","r" );
   fscanf(fp,"%d",&y);   /* get aileron channel number */

   count_high();
   for( x= 0; x < 20; ++x ){
      vals[x]= count_high();
      }

   for( x= y; x < 20; ++x ){
      if( vals[x-y] > 2 * vals[x] ) break;   /* look4 long pulse */
      }
   delay_val=  vals[x];    /* alieron value */

}

int findradio( char * string ){
int far * p;
int x;

   p= MK_FP( 0,0x408 );  /* find lpt1 */

   for( x= 1; x < 4; ++x ){
      printf("Looking for radio on LPT%d\n",x);

      port = *p++;
      status= port + 1;
      control= port + 2;
      if( port == 0 ) continue;  /* no lpt */

      outportb(control,0x4);  /* set pullup high */
      if( find_signal() && find_signal() ){      /* de-glitch */
         find_invert();
         find_delay();
         return 1;
         }

      }
   return 0;

}
