#define AC_INDEX 0x3c0  /* data with toggle - read input status 1 to reset*/

#define SC_INDEX 0x3c4
#define SC_DATA 0x3c5
#define SC_MAP_MASK 2    /* address of map mask, 1st 4 bits */

#define GC_INDEX 0x3ce
#define GC_DATA 0x3cf
#define GC_COLOR_COMPARE 2
#define GC_COLOR_DONT_CARE 7
#define GC_READ_MAP 4      /* select plane to read */
#define GC_MODE  5         /* address of reg bits 01 are write mode */
 #define READ_MODE 0x8     /* bit for read mode in GC_MODE reg*/
#define BIT_MASK 8         /* address of bit mask */
#define GC_BIT_MASK 8      /* same reg,diff name */
#define GC_SET_RESET 0     /* set reset data , bits 0-3 */
#define GC_ENABLE_SET_RESET 1  /* set reset enable , bits 0-3 */
#define GC_ROTATE 3  /*  bits 012 is rotate,  bits 34 alu function */
  #define ALU_UNMOD 0
  #define ALU_AND 0x08
  #define ALU_OR  0x10
  #define ALU_XOR 0x18


#define CRTC_INDEX 0x3d4   
#define CRTC_DATA 0x3d5
#define START_ADDRESS_HIGH 0xc
#define START_ADDRESS_LOW  0xd
#define CRTC_OFFSET 0x13

#define INPUT_STATUS1 0x3da
  #define VSYNC_MASK 0x08
  #define DE_MASK 0x01       /* display enabled */

